(function ($) {

Drupal.behaviors.imageeditor = {};
Drupal.behaviors.imageeditor.attach = function(context, settings) {
  //$.extend(true, Drupal.settings, settings);
  
  var $imageeditor_divs = $('.imageeditor', context);
  var $imageeditor_divs_existing = $('.imageeditor.imageeditor-existing', context);
  
  $imageeditor_divs.find('div.editors').find('div').not('.paintweb, .aviary-feather').unbind('click').click(
    function() {
      var codename = $(this).attr('class').split(' ')[0].replace(/-/g, '_');
      var field_name = $(this).parent().parent().find('.field-name').attr('value');
      var element_id = $(this).parent().parent().find('.element-id').attr('value');
      var url = $(this).parent().parent().find('.url').attr('value');
      Drupal.settings.imageeditor.save = new Object();
      Drupal.settings.imageeditor.save.element_id = element_id;
      Drupal.settings.imageeditor.save.replace = Drupal.settings.imageeditor[field_name]['imageeditor_replace'];
      var options = Drupal.settings.imageeditor[codename].options;
      if (typeof(url) != 'undefined') {
        options[Drupal.settings.imageeditor[codename]['image_url_param']] = url;
        Drupal.settings.imageeditor.save.create = 0;
        if (codename == 'picnik') {options['_imageid'] = element_id;}
      }
      else {
        delete options[Drupal.settings.imageeditor[codename]['image_url_param']];
        Drupal.settings.imageeditor.save.create = 1;
        if (codename == 'picnik') {delete options['_imageid'];}
      }
      Drupal.imageeditor[Drupal.settings.imageeditor[codename]['launch_type']].show(options);
    }
  );
  
  $imageeditor_divs.find('div.paintweb').unbind('click').click(
    function() {
      var field_name = $(this).parent().parent().find('.field-name').attr('value');
      var element_id = $(this).parent().parent().find('.element-id').attr('value');
      var url = $(this).parent().parent().find('.url').attr('value');
      Drupal.settings.imageeditor.save = new Object();
      Drupal.settings.imageeditor.save.element_id = element_id;
      Drupal.settings.imageeditor.save.replace = Drupal.settings.imageeditor[field_name]['imageeditor_replace'];
      pw = new PaintWeb();
      pw.config.configFile = Drupal.settings.imageeditor.paintweb.options.configFile;
      if (url) {
        Drupal.settings.imageeditor.save.create = 0;
        var img = document.createElement('img');
        img.src = url;
        pw.config.imageLoad = img;
        Drupal.settings.imageeditor.url = url;
      }
      else {
        Drupal.settings.imageeditor.save.create = 1;
        var canvas = document.createElement('canvas');
        canvas.setAttribute('width', 600);
        canvas.setAttribute('height', 600);
        var img = document.createElement('img');
        img.src = canvas.toDataURL('image/png');
        pw.config.imageLoad = img;
        Drupal.settings.imageeditor.url = 'undefined';
      }
      Drupal.imageeditor.overlay.show();
      pw.config.guiPlaceholder = $('.imageeditor-internal').get(0);
      pw.config.viewportWidth = $('.imageeditor-internal').width() + 'px';
      pw.config.viewportHeight = ($('.imageeditor-internal').height() - 140) + 'px';
      pw.init(function (ev) {
        if (ev.state === PaintWeb.INIT_ERROR) {
          alert('PaintWeb failed loading!');
        }
      });
      pw.events.add('imageSave', paintweb_save);
      //delete pw;
      delete img;
      delete canvas;
    }
  );
  
  $imageeditor_divs_existing.find('div.aviary-feather').unbind('click').click(
    function() {
      var field_name = $(this).parent().parent().find('.field-name').attr('value');
      var element_id = $(this).parent().parent().find('.element-id').attr('value');
      Drupal.settings.imageeditor.save = new Object();
      Drupal.settings.imageeditor.save.element_id = element_id;
      Drupal.settings.imageeditor.save.replace = Drupal.settings.imageeditor[field_name]['imageeditor_replace'];
      var url = $(this).parent().parent().find('.url').attr('value');
      Drupal.featherEditor.launch({image: $(this).parent().parent().parent().parent().find('.image-preview').find('img').attr('id', element_id).attr('id'), url: url});
    }
  );
  
  $imageeditor_divs_existing.find('div.uploaders').find('div').unbind('click').click(
    function() {
      var tmp = $(this).attr('class').split(' ');
      var codename = tmp[0].replace(/-/g, '_');
      var $url = $(this).parent().parent().find('.url');
      var filepath = $(this).parent().parent().find('.filepath').attr('value');
      $.ajax({
        type: 'GET',
        url: Drupal.settings.imageeditor[codename].upload_url,
        async: false, // explicitly need the user to wait while we load...
        data: {'filepath': filepath},
        success: function(data) {$url.attr('value', data);},
        error: function(msg) {alert("Failed uploading: " + msg);}
      });
    }
  );
  
  //to show as overlay over the image preview
  $imageeditor_divs_existing.each(
    function(index) {
      var field_name = $(this).find('.field-name').attr('value');
      if (Drupal.settings.imageeditor[field_name]['imageeditor_icons_position'] == 1) {
        $(this).parent().css({'position': 'relative', 'width': '100px'}).hover(
          function() {
            $(this).find('.imageeditor').css({'position': 'absolute', 'top': 0}).show();
          },
          function() {
            $(this).find('.imageeditor').hide();
          }
        ).find('.imageeditor').hide();
      }
    }
  );
};

function paintweb_save(ev) {
  ev.preventDefault();
  var tmp = ev.dataURL.split(',');
  Drupal.imageeditor.overlay.hide();
  
  $.ajax({
    type: 'POST',
    url: Drupal.settings.imageeditor.paintweb.options.saveurl,
    async: false, // explicitly need the user to wait while we load...
    data: {'data': tmp[1], 'url': Drupal.settings.imageeditor.url},
    success: 
      function(data) {
    	Drupal.settings.imageeditor.save.image = data;
    	Drupal.imageeditor.save.save();
      },
    error: function(msg) {alert("Failed saving: " + msg);}
  });
  Drupal.settings.imageeditor.url = 'undefined';
  
  //pw.events.dispatch(new appEvent.imageSaveResult(true));
  //pw.events.dispatch(new appEvent.imageSaveResult(false));
};

if (typeof(Drupal.imageeditor) == 'undefined') {
Drupal.imageeditor = function() {
  function windowSize() {
    var w = 0, h = 0;
    if(!(document.documentElement.clientWidth == 0)) {
      w = document.documentElement.clientWidth;
      h = document.documentElement.clientHeight;
    }
    else {
      w = document.body.clientWidth;
      h = document.body.clientHeight;
    }
    return {width:w,height:h};
  }
  function buildUrl(opt) {
    var url = opt.launch_url;
    var first_attr = 'yes';
    if (url.indexOf('?') > -1) {first_attr = 'no';} //for non-clean URLs
    for (var attribute in opt) {
      if(attribute !== 'launch_url') {
        if (first_attr == 'yes') {
          url += "?"+ attribute +"="+ escape(opt[attribute]);
          first_attr = 'no';
        }
        else {
          url += "&"+ attribute +"="+ escape(opt[attribute]);
        }
      }
    }
    return url;
  }
  var bo = {
    ie: window.ActiveXObject,
    ie6: window.ActiveXObject && (document.implementation != null) && (document.implementation.hasFeature != null) && (window.XMLHttpRequest == null),
    quirks: document.compatMode==='BackCompat'
  };
  return {
    overlay: {
      show: function(options) {
        var iframe = document.createElement('iframe'),
        div = document.createElement('div'),
        idiv = document.createElement('div'),
        div_close = document.createElement('div');
        iframe.className = 'imageeditor-iframe';
        div.className = 'imageeditor-external';
        idiv.className = 'imageeditor-internal';
        div_close.className = 'imageeditor-close';
        
        if((bo.ie && bo.quirks) || bo.ie6) {
          var size = windowSize();
          div.style.position = 'absolute';
          div.style.width = size.width + 'px';
          div.style.height = size.height + 'px';
          div.style.setExpression('top', "(t=document.documentElement.scrollTop||document.body.scrollTop)+'px'");
          div.style.setExpression('left', "(l=document.documentElement.scrollLeft||document.body.scrollLeft)+'px'");
        }
        
        if((bo.ie && bo.quirks) || bo.ie6) {
          idiv.style.position = 'absolute';
          idiv.style.setExpression('top', "40+((t=document.documentElement.scrollTop||document.body.scrollTop))+'px'");
          idiv.style.setExpression('left', "40+((l=document.documentElement.scrollLeft||document.body.scrollLeft))+'px'");
        }
        
        document.body.appendChild(div);
        idiv.style.width = (div.offsetWidth - 80) +'px';
        idiv.style.height = (div.offsetHeight - 80) +'px';
        document.body.appendChild(idiv);
        idiv.appendChild(div_close);
        
        if (typeof options != 'undefined') {
          iframe.style.width = (div.offsetWidth - 80) +'px';
          iframe.style.height = (div.offsetHeight - 80) +'px';
          iframe.src = buildUrl(options);
          idiv.appendChild(iframe);
        }
        
        $('div.imageeditor-close').click(
          function() {
            Drupal.imageeditor.overlay.hide();
          }
        );
      },
      hide: function() {
        $('.imageeditor-external').remove();
        $('.imageeditor-internal').remove();
        $('.imageeditor-close').remove();
      }
    },
    popup: {
      show: function(options) {
        popup_window = window.open(buildUrl(options), 'imageeditor', 'location=no,menubar=no,resizable=yes,scrollbars=yes,status=no,titlebar=yes,toolbar=no,channelmode=yes,fullscreen=yes');
        popup_window.focus();
      }
    },
    save: {
      save: function() {
        var edit_id = Drupal.settings.imageeditor.save.element_id.replace(/[0-9]+$/, '');
        //SAVE NEW
        if (Drupal.settings.imageeditor.save.create || !Drupal.settings.imageeditor.save.replace) {
          //upload new element
          $('a[id^="'+edit_id+'"][id$="-remote-source"]').filter(function() {var regex = new RegExp('^'+edit_id+'[0-9]+-remote-source$'); return regex.test(this.id);}).click();
          $('input[id^="'+edit_id+'"][id$="-filefield-remote-url"]').filter(function() {var regex = new RegExp('^'+edit_id+'[0-9]+-filefield-remote-url$'); return regex.test(this.id);}).val(Drupal.settings.imageeditor.save.image);
          $('input[id^="'+edit_id+'"][id$="-filefield-remote-transfer"]').filter(function() {var regex = new RegExp('^'+edit_id+'[0-9]+-filefield-remote-transfer$'); return regex.test(this.id);}).mousedown();
        }
        //REPLACE
        else {
          if (typeof $('a[id^="'+edit_id+'"][id$="-remote-source"]').filter(function() {var regex = new RegExp('^'+edit_id+'[0-9]+-remote-source$'); return regex.test(this.id);})[0] != 'undefined') {
            //fill in remote url
            $('a[id^="'+edit_id+'"][id$="-remote-source"]').filter(function() {var regex = new RegExp('^'+edit_id+'[0-9]+-remote-source$'); return regex.test(this.id);}).click();
            $('input[id^="'+edit_id+'"][id$="-filefield-remote-url"]').filter(function() {var regex = new RegExp('^'+edit_id+'[0-9]+-filefield-remote-url$'); return regex.test(this.id);}).val(Drupal.settings.imageeditor.save.image);
            //call submit through remove button
            $('input[id="'+Drupal.settings.imageeditor.save.element_id+'-remove-button"]').mousedown();
          }
          else {
            //remove element
            $('input[id="'+Drupal.settings.imageeditor.save.element_id+'-remove-button"]').mousedown();
            //upload new element in .5 seconds
            setTimeout("Drupal.imageeditor.save.internal();", 500);
          }
        }
      },
      internal: function() {
        var edit_id = Drupal.settings.imageeditor.save.element_id.replace(/[0-9]+$/, '');
        if (typeof $('a[id^="'+edit_id+'"][id$="-remote-source"]').filter(function() {var regex = new RegExp('^'+edit_id+'[0-9]+-remote-source$'); return regex.test(this.id);})[0] != 'undefined') {
          $('a[id^="'+edit_id+'"][id$="-remote-source"]').filter(function() {var regex = new RegExp('^'+edit_id+'[0-9]+-remote-source$'); return regex.test(this.id);}).click();
          $('input[id^="'+edit_id+'"][id$="-filefield-remote-url"]').filter(function() {var regex = new RegExp('^'+edit_id+'[0-9]+-filefield-remote-url$'); return regex.test(this.id);}).val(Drupal.settings.imageeditor.save.image);
          $('input[id^="'+edit_id+'"][id$="-filefield-remote-transfer"]').filter(function() {var regex = new RegExp('^'+edit_id+'[0-9]+-filefield-remote-transfer$'); return regex.test(this.id);}).mousedown();
        }
        else {
          setTimeout("Drupal.imageeditor.save.internal();", 500);
        }
      }
    }
  };
}();
}

})(jQuery);
